<? # NewsStats version 1.06
   # Copyright Matthew Somerville 2002

if ($_GET[hours]) {

$hours = explode(",",$_GET[hours]);
$ltos = $hours; rsort($ltos,SORT_NUMERIC); $largest = $ltos[0];
Header("Content-Type: image/png");
$scale = 1;
if ($largest<20) $height = 30;
elseif ($largest>190) { $scale = $largest/190; $height=200; }
else $height = $largest + 10;
$base = $height-6;
$im = @ImageCreate(112,$height) or die ("Cannot init image");
$white = ImageColorAllocate($im,255,255,255);
$black = ImageColorAllocate($im,0,0,0);
$red = ImageColorAllocate($im,255,0,0);
ImageString($im,1,8,$height-8,"0",$black);
if ($height>109)
  ImageString($im,1,0,2,($height-10)*$scale,$black);
else
  ImageString($im,1,4,2,($height-10)*$scale,$black);

for ($k=0; $k<24; ++$k) {
  if ($base-$hours[$k]/$scale<4 && $hours[$k] != $largest) {
    ImageFilledRectangle($im,17+$k*4,6,$k*4+19,$base,$red);
    ImageSetPixel($im,17+$k*4,4,$red);
    ImageSetPixel($im,19+$k*4,4,$red);
  } else
    ImageFilledRectangle($im,17+$k*4,$base-$hours[$k]/$scale,$k*4+19,$base,$red);
}
ImageLine($im,16,4,16,$base,$black);
ImageLine($im,16,$base,111,$base,$black);
ImagePNG($im);
exit;

} ?>
<html><head><title>NewsStats</title></head><body>
<img align="right" alt="NewsStats sprite" src="newsstats.gif" height="34" width="44" /><h1>Newsgroup post counter</h1><?

if (!$_GET[top] || preg_match("/\D/",$_GET[top])) $_GET[top]=10;

if ("NewsBase" == $_GET[server]) { showform(); newsbase(); }
elseif ("MsgServe" == $_GET[server]) { showform(); msgserve(); }
elseif ($_GET[server]) {
  print "<p><big><em>Invalid message server specified</em></big></p>";
  showform();
}
else showform();

function formSelect($default,$options) {
  foreach ($options as $option) {
    $select = ($option == $default) ? ' selected="selected"' : '';
    $html .= "<option$select>$option</option>";
  }
  return $html;
}

function showform() {
  global $PHP_SELF; ?>
Select your message server and other options as you wish, then click Process.
<form action="<?=$PHP_SELF ?>" method="get">
<table cellpadding="3" cellspacing="2" border="0">
<tr><th align="right">Message server:</th>
<td><select name="server"><?=formSelect($_GET[server],array("NewsBase","MsgServe")) ?></select></td></tr>
<tr><th align="right">Results per newsgroup:</th><td><input type="text" name="top" value="<?=$_GET[top] ?>" size="3" /></td></tr>
<tr><th align="right">Posting times graphs?</th><td><input type="checkbox" name="graph" value="1"<? if ($_GET[graph]) print ' checked="checked"'; ?> /></td></tr>
<tr><th align="right">Only match groups containing:</th><td><input type="text" name="wild" value="<?=$_GET[wild] ?>" size="20" /></td></tr>
<tr><th align="right">Only match groups <em>not</em> containing:</th><td><input type="text" name="wildnot" value="<?=$_GET[wildnot] ?>" size="20" /></td></tr>
<tr><th align="right">Only match posts from:</th><td><input type="text" name="person" value="<?=$_GET[person] ?>" size="20" /></td></tr>
<tr><th align="right">Collate results?</th><td><input type="checkbox" name="collate" value="1"<? if ($_GET[collate]) print ' checked="checked"'; ?> /></td></tr>
<tr><td colspan="2" align="right"><input type="submit" value="Process" /></td></tr>
</table>
</form>
<p align="right">&copy; Matthew Somerville 2002
<br />Web site: <a href="http://www.dracos.co.uk/riscos/programs/newsstats/">http://www.dracos.co.uk/riscos/programs/newsstats/</a>
<br />Email: <a href="mailto:matthew-newsstats@dracos.co.uk">matthew-newsstats@dracos.co.uk</a></p>
<? }

function error($err) {
  print "<p><big><em>$err</em></big></p>";
}

function msgserve() {
  $f = file('/<NewsDir$Dir>/MsgServe/Transports/NewsHound/groups'); if (!$f) { error("NewsHound groups list not found"); return; }
  $g = file('/<NewsDir$Dir>/MsgServe/Groups'); if (!$g) { error("MsgServe groups list not found"); return; }
  foreach ($g as $line) {
    preg_match("/^group (.*?) .* N(.*?) .* G(.*)$/",$line,$matches);
    $num[$matches[1]]=$matches[2];
    $gnum[$matches[1]]=$matches[3];
  }

  foreach ($f as $group) {
    $group = trim(preg_replace("/ .*/","",$group));
    if ($num[$group] && wildmatches($group)) $groups[] = array(name => $group, num=>$num[$group], gnum=>$gnum[$group]);
  }
  if ($groups) groups_scan($groups);
  else error("No groups match your criteria");
}

function wildmatches($group) {
  $wild = quotemeta($_GET[wild]);
  $wildnot = quotemeta($_GET[wildnot]);
  if ($wild && !preg_match("/$wild/",$group)) return 0;
  if ($wildnot && preg_match("/$wildnot/",$group)) return 0;
  return 1;
}

function newsbase() {
  $f = file('/<NewsDir$Dir>/newsbase/config/NewsHound/Groups'); if (!$f) { error("NewsHound groups list not found"); return; }
  $g = file('/<NewsDir$Dir>/newsbase/groupinfo'); if (!$g) { error("NewsBase groups list not found"); return; }
  foreach ($g as $line) {
    preg_match("/^group (.*?) .* N(.*?) /",$line,$matches);
    $num[$matches[1]]=$matches[2];
  }

  foreach ($f as $group) {
    $group = trim(preg_replace("/ .*/","",$group));
    if ($num[$group] && wildmatches($group)) $groups[] = array(name => $group, num=>$num[$group]);
  }
  if ($groups) groups_scan($groups);
  else error("No groups match your criteria");
}

function groups_scan($groups) {
  global $posts,$PHP_SELF;
  $table = "";
  if ($_GET[collate]) {
    $count=0; $countn = 0; $hours=array(); $posts=array();
    for ($k=0; $k<24; ++$k) $hours[$k]=0; $grouplist = array();
  }

  $person = quotemeta($_GET[person]);
  foreach ($groups as $group) {
    $g = $group[name];
    $overview = getoverview($group);
    if (!$overview) {
      $table .= "<p><strong>$g</strong> <small>($group[num])</small> - <em>has no overview file</em></p>\n";
    } else {
      if (!$_GET[collate]) {
        $count = 0; $hours = array(); $posts = array();
        for ($k=0; $k<24; ++$k) $hours[$k]=0;
      }
      foreach ($overview as $line) {
        ++$count;
        $ov = explode("\t",$line);
        $sub = $ov[1];
        $from = $ov[2];
        $date = $ov[3];
        $day = substr($date,0,3);
        preg_match("/ (\d+):/",$date,$matches);
        $hour = $matches[1] + 0;
        if (!$person) { $hours[$hour]++; $posts[$from]++; }
        if ($person && preg_match("/$person/",$from)) {
          $hours[$hour]++; $posts[$from]++;
        }
      }
      if ($_GET[collate]) {
        $countn += $group[num];
        $grouplist[] = $g;
      } else {
        uksort($posts,"cmp");
        $row = toplist($posts);
        if ($row) {
          $hoursstr = join(",",$hours);
          $table .= "<p><strong>$g</strong> <small>($group[num],$count)</small></p>";
          if ($_GET[graph] && $hoursstr) $table .= "<img align=\"left\" hspace=\"5\" src=\"$PHP_SELF?hours=$hoursstr\" />";
          $table .= "$row\n";
        }
      }
    }
  }
  if ($_GET[collate]) {
    uksort($posts,"cmp");
    $row = toplist($posts);
    if ($row) {
      $hoursstr = join(",",$hours);
      $table .= "<p><strong>Collated groups</strong> <small>($countn,$count)</small><br />[ ".join(", ",$grouplist).' ]</p>';
      if ($_GET[graph] && $hoursstr) $table .= "<img align=\"left\" hspace=\"5\" src=\"$PHP_SELF?hours=$hoursstr\" />";
      $table .= "$row\n";
    }
  }
  if ($table) print "<h2>Results</h2>$table";
}

function toplist($posts) {
  foreach ($posts as $poster => $num) {
    $wibble[$num][] = $poster;
  }

  $i=0; $j=1; $blk = ""; $fin=0;
  foreach ($wibble as $num => $arr) {
    $j=$i+1; $row= array();
    foreach($arr as $poster) {
      $row[] = "<tr><td>".htmlentities($poster).'</td></tr>';
      ++$i; if ($i==$_GET[top]) $fin=1;
    }
    $row[0] = substr($row[0],4); $rs = sizeof($row);
    $blk .= "<tr><td valign=\"top\" align=\"right\"";
    if ($rs>1) $blk .= " rowspan=\"$rs\"";
    $blk .= ">$j.</td><td valign=\"top\"";
    if ($rs>1) $blk .= " rowspan=\"$rs\"";
    $blk .= ">($num)</td>".join("\n",$row);
    if ($fin==1) break;
  }
  if ($blk) $blk = "<table align=\"center\" border=\"0\" cellpadding=\"3\" cellspacing=\"0\"><tr><th>Pos.</th><th>No</th><th>Name</th></tr>$blk</table><br clear=\"all\" />";
  return $blk;
}

function getoverview($group) {
  if ("NewsBase" == $_GET[server]) {
    $dirs = explode(".",$group[name]);
    foreach ($dirs as $dir) {
      while (strlen($dir)>10) {
        $str .= substr($dir,0,9)."~/";
        $dir = substr($dir,9);
      }
      $str .= $dir."/";
    }
    $str = "/<NewsDir\$Dir>/news/$str~overview";
  } elseif ("MsgServe" == $_GET[server]) {
    $dir = floor($group[gnum]/77);
    $subdir = $group[gnum]%77;
    $str = "/<NewsDir\$Dir>/MsgServe/Spool/0/$dir/$subdir/Overview";
  }
  return file($str);
}

function cmp($a,$b) {
  global $posts;
  if ($posts[$a]==$posts[$b]) return 0;
  return ($posts[$a]>$posts[$b]) ? -1 : 1;
}

?>
</body>
</html>
